<?php

class agrovoc_local extends agrovoc {

	var $source = '';
	var $agrovoc_ws_url = '';
	var $agrovoc_ws_uri = '';
  var $_agrovoc_api_client = NULL;
	// lang is language, source is remote or local

  function __construct($agrovoc_ws_url, $agrovoc_ws_uri) {
	  $this->source = 'local';
	  $this->agrovoc_ws_url = $agrovoc_ws_url;
	  $this->agrovoc_ws_uri = $agrovoc_ws_uri;
	}
	

	// only declaration to implement in subclasses according source
  function simple_search_by_mode2($searchstring = NULL, $searchmode = 'exact', $separator = ',', $as_array = TRUE, $limit = 1, $filter_language = '') {
  $array_terms = array();
   switch ($searchmode) {
     case 'starting'   : $condition = "LIKE '%s%%'"; break;
     case 'containing' : $condition = "LIKE '%%%s%%'"; break;
     case 'exact'      : $condition = "= '%s'"; break;
     case 'end with'   : $condition = "LIKE '%%%s'"; break;
     case 'exact word' : $condition = "='%s'"; break;
    }
   $sql = "SELECT * FROM {agrovocterm} WHERE " . ($filter_language !== '' ? "languagecode = '%s' AND " : '') . "termspell " . $condition;
   $parameters = array($searchstring);
   if ($filter_language !== '') {array_unshift($parameters, strtoupper($filter_language)); }
   $rows = db_query_range($sql, $parameters, 0, $limit);
   $num = db_affected_rows();
   if(!empty($num)) {
   	 $i = 0;
     while ($row = db_fetch_object($rows)) {
     	 $i++;
       $array_terms[$i]['id'] = $row->termcode;
       $array_terms[$i]['term'] = $row->termspell;   
       $array_terms[$i]['lang'] = $row->languagecode;
       $string_terms[$i] = implode(',', $array_terms[$i]);
     }
   }
  $output = $as_array == TRUE ? $array_terms : "[" . implode(',', $string_terms) .  "NumberOfResults," . $num . "]";
  return $output;
}

	// only declaration to implement in subclasses according source	
	function get_all_labels_by_termcode2($termcode = NULL, $separator = ',', $as_array = TRUE) {
    $sql = "SELECT * FROM {agrovocterm} WHERE termcode = '%s'";
    $rows = db_query($sql, $termcode);
    while ($row = db_fetch_object($rows)) {
      $array_terms[$row->languagecode] = $row->termspell;
      $string_terms[] = implode(',', array($row->termspell, $row->languagecode));
    }
    $output = $as_array == TRUE ? $array_terms : "[" . implode(',', $string_terms) . "]";    
    return $output;
	}

  function agrovocfield_load_object($label) {
    $languages_supported =  i18n_supported_languages();
  	try {
      $term = $this->simple_search_by_mode2($label, 'exact', ',', TRUE, 1);
      if(count($term) == 0) {
        throw new Exception(t('@label is not a AGROVOC term.', array('@label' => $label)));
      }
      $term = array_values($term);
      $term_labels = $this->get_all_labels_by_termcode2($term[0]['id']);
      $agrovoc = new stdClass();
      $agrovoc->id = $term[0]['id'];
      foreach ($languages_supported  as $k => $v) {
       // Use substr because FAO Chinese language is ZH and Drupal Chinese language is zh-hans, 
       // therefore, you  need only 2 first characters.
      if(isset($term_labels[strtoupper(substr($k, 0, 2))])){ 
        $labels[$k] = $term_labels[strtoupper(substr($k, 0, 2))];
      }
      }
      $agrovoc->labels = $labels;
      return $agrovoc;      
    }
    catch (Exception $e) { 
       drupal_set_message($e->getMessage(), 'error');
       $agrovoc_null = new stdClass();
       $agrovoc_null->id = '';
       foreach ($languages_supported  as $k => $v) {
         $labels[$k] = $term_labels[strtoupper(substr($k, 0, 2))];
       }    
       $agrovoc_null->labels = $labels;
       return $agrovoc_null;  
    }
  }
  
}  
